--AH:ScriptId=7f414e76-4a68-4978-bc78-20b8d826752d;1745
BEGIN TRAN


SET IDENTITY_INSERT [BuildExecution_DeploymentPlans] ON
-- Populate with one deployment plan for every execution
-- Use BEDP_ID = Execution_Id to make migration easier
INSERT INTO [BuildExecution_DeploymentPlans]
(
	[BuildExecution_DeploymentPlan_Id],
	[Execution_Id],
	[Original_DeploymentPlan_Id],
	[Original_DeploymentPlan_Name]
)
SELECT [BuildExecution_DeploymentPlan_Id] = BE.[Execution_Id],
       [Execution_Id] = BE.[Execution_Id],
	   [Original_DeploymentPlan_Id] = 0,
       [Original_DeploymentPlan_Name] = NULL
  FROM [BuildExecutions] BE
SET IDENTITY_INSERT [BuildExecution_DeploymentPlans] OFF

UPDATE [BuildExecutions]
   SET [Initial_BuildExecution_DeploymentPlan_Id] = [Execution_Id]
   
-- Migrate BEP to BEDPAG
INSERT INTO [BuildExecution_DeploymentPlanActionGroups]
    ([BuildExecution_DeploymentPlan_Id]
    ,[Original_DeploymentPlanActionGroup_Sequence]
    ,[Original_Deployable_Name]
    ,[Original_Deployable_Application_Name]
    ,[Original_DeploymentPlanActionGroup_Id]
    ,[Original_DeploymentPlanActionGroup_Name])
SELECT [BuildExecution_DeploymentPlan_Id] = BEP.[Execution_Id],
       [Original_DeploymentPlanActionGroup_Sequence] = ROW_NUMBER() OVER (PARTITION BY [Execution_Id]
	                                                                      ORDER BY [Execution_Id], [PlanExecution_Sequence], [Original_PlanActionGroup_Id]),
       [Original_Deployable_Name] = BEP.[Deployable_Name],
       [Original_Deployable_Application_Name] = NULL,
       [Original_DeploymentPlanActionGroup_Id] = BEP.[Original_PlanActionGroup_Id],
       [Original_DeploymentPlanActionGroup_Name] = BEP.[ActionGroup_Name]
  FROM [BuildExecution_Plans] BEP
  
-- Add BEDP_Id, Original_DPAG_Seq FKEY columns to BEAGA
ALTER TABLE [BuildExecution_ActionGroupActions]
	ADD [BuildExecution_DeploymentPlan_Id] INT NULL
GO

UPDATE [BuildExecution_ActionGroupActions]
   SET [BuildExecution_DeploymentPlan_Id] = [Execution_Id]

ALTER TABLE [BuildExecution_ActionGroupActions]
	ALTER COLUMN [BuildExecution_DeploymentPlan_Id] INT NOT NULL
	
	
ALTER TABLE [BuildExecution_ActionGroupActions]
	ADD [Original_DeploymentPlanActionGroup_Sequence] INT NULL
GO


UPDATE BEAGA
   SET [Original_DeploymentPlanActionGroup_Sequence] = BEPPY.[Seq]
  FROM [BuildExecution_ActionGroupActions] BEAGA
       INNER JOIN (SELECT [Execution_Id] , [Original_PlanActionGroup_Id],
	                      [Seq] =ROW_NUMBER() OVER (PARTITION BY BEP.[Execution_Id]
	                             ORDER BY BEP.[Execution_Id], BEP.[PlanExecution_Sequence], BEP.[Original_PlanActionGroup_Id])
	                 FROM [BuildExecution_Plans] BEP) BEPPY
               ON BEPPY.[Original_PlanActionGroup_Id] = BEAGA.[Original_PlanActionGroup_Id]
              AND BEPPY.[Execution_Id] = BEAGA.[Execution_Id]

ALTER TABLE [BuildExecution_ActionGroupActions]
	ALTER COLUMN [Original_DeploymentPlanActionGroup_Sequence] INT NOT NULL

ALTER TABLE [BuildExecution_ActionGroupActions]
	ADD CONSTRAINT [FK__BuildExecution_ActionGroupActions__BuildExecution_DeploymentPlanActionGroups]
		FOREIGN KEY ([BuildExecution_DeploymentPlan_Id], [Original_DeploymentPlanActionGroup_Sequence])
		 REFERENCES [BuildExecution_DeploymentPlanActionGroups] ([BuildExecution_DeploymentPlan_Id], [Original_DeploymentPlanActionGroup_Sequence])


-- Drop old constraints
ALTER TABLE [BuildExecution_ActionGroupActions]
	DROP CONSTRAINT [FK__BuildExecution_PlanActions__BuildExecution_Plans]

ALTER TABLE [BuildExecution_ActionGroupActions]
	DROP CONSTRAINT [FK__BuildExecution_PlanActions__Servers]

-- Drop old indexes
DROP INDEX [IX__BuildExecution_PlanActions__Execution_Id] ON [BuildExecution_ActionGroupActions]
DROP INDEX [IX__BuildExecution_PlanActions__Original_PlanActionGroup_Id] ON [BuildExecution_ActionGroupActions]

-- Drop old columns
ALTER TABLE [BuildExecution_ActionGroupActions]
	DROP COLUMN [Execution_Id]

ALTER TABLE [BuildExecution_ActionGroupActions]
	DROP COLUMN [Server_Id]

ALTER TABLE [BuildExecution_ActionGroupActions]
	DROP COLUMN [Original_PlanActionGroup_Id]
	
	
-- Drop BEP
DROP TABLE [BuildExecution_Plans]

COMMIT