EXEC [dbo].[__BuildMaster_AddStoredProcInfo]
    /* StoredProc_Name         */ 'ConfigurationFiles_GetConfigurationFileDeployments',
    /* Internal_Indicator      */ 'N',
    /* ReturnType_Name         */ 'DataTable',
    /* DataTableNames_Csv      */ 'ConfigurationFileDeployments_Extended',
    /* OutputPropertyNames_Csv */ NULL,
    /* Description_Text        */ 'Gets a list of all configuration file deployments based on the specified criteria.'
GO


IF OBJECT_ID('[ConfigurationFiles_GetConfigurationFileDeployments]') IS NOT NULL DROP PROCEDURE [ConfigurationFiles_GetConfigurationFileDeployments]
GO

SET QUOTED_IDENTIFIER ON
GO

CREATE PROCEDURE [ConfigurationFiles_GetConfigurationFileDeployments]
(
	@Application_Id INT,
    @ConfigurationFile_Id INT = NULL,
    @Deployable_Id INT = NULL,
    @Instance_Name VARCHAR(100) = NULL,
    @Server_Id INT = NULL,
	@File_Count INT = NULL
)
AS
BEGIN

	SET NOCOUNT ON

	--Use RowCount to limit results 
	IF (@File_Count IS NOT NULL AND @File_Count > 0)
	BEGIN
		SET ROWCOUNT @File_Count
	END

	SELECT *
	  FROM [ConfigurationFileDeployments_Extended]
     WHERE [ConfigurationFile_Id] = COALESCE(@ConfigurationFile_Id, [ConfigurationFile_Id])
	   AND [Application_Id] = COALESCE(@Application_Id, [Application_Id])
       AND (@Deployable_Id IS NULL OR ([Deployable_Id] = @Deployable_Id))
       AND [Instance_Name] = COALESCE(@Instance_Name, [Instance_Name])
       AND [Server_Id] = COALESCE(@Server_Id, [Server_Id])
	  ORDER BY [DeployedOn_Date] DESC

END
GO

GRANT EXECUTE ON [ConfigurationFiles_GetConfigurationFileDeployments] TO [BuildMasterUser_Role]
