EXEC [dbo].[__BuildMaster_AddStoredProcInfo]
    /* StoredProc_Name         */ 'Executions_ImportLogScope',
    /* Internal_Indicator      */ 'Y',
    /* ReturnType_Name         */ 'void',
    /* DataTableNames_Csv      */ NULL,
    /* OutputPropertyNames_Csv */ 'Scope_Sequence',
    /* Description_Text        */ 'Imports a log scope.'
GO

IF OBJECT_ID('[Executions_ImportLogScope]') IS NOT NULL DROP PROCEDURE [Executions_ImportLogScope]
GO

SET QUOTED_IDENTIFIER ON
GO

CREATE PROCEDURE [Executions_ImportLogScope]
(
	@Execution_Id INT,
	@Scope_Sequence INT,
	@Parent_Scope_Sequence INT,
	@Scope_Name VARBINARY(MAX),
	@Start_Date DATETIME,
	@End_Date DATETIME,
	@HighestLogEntry_Level INT
)
AS
BEGIN

SET NOCOUNT ON

BEGIN TRY
	BEGIN TRANSACTION

	INSERT INTO [ScopedExecutionLogs]
	(
		[Execution_Id],
		[Scope_Sequence],
		[Parent_Scope_Sequence],
		[Scope_Name],
		[Start_Date],
		[End_Date],
		[HighestLogEntry_Level]
	)
	VALUES
	(
		@Execution_Id,
		@Scope_Sequence,
		@Parent_Scope_Sequence,
		@Scope_Name,
		@Start_Date,
		@End_Date,
		@HighestLogEntry_Level
	)

	COMMIT
END TRY BEGIN CATCH
	IF XACT_STATE()<>0 ROLLBACK
	EXEC [HandleError]
END CATCH


END
GO

GRANT EXECUTE ON [Executions_ImportLogScope] TO [BuildMasterUser_Role]
