EXEC [dbo].[__BuildMaster_AddStoredProcInfo]
    /* StoredProc_Name         */ 'Promotions_DeleteApproval',
    /* Internal_Indicator      */ 'N',
    /* ReturnType_Name         */ 'void',
    /* DataTableNames_Csv      */ NULL,
    /* OutputPropertyNames_Csv */ NULL,
    /* Description_Text        */ 'Deletes an approval for a promotion.'
GO

IF OBJECT_ID('[Promotions_DeleteApproval]') IS NOT NULL DROP PROCEDURE [Promotions_DeleteApproval]
GO

SET QUOTED_IDENTIFIER ON
GO

CREATE PROCEDURE [Promotions_DeleteApproval]
(
	@Approval_Id INT
) AS BEGIN

SET NOCOUNT ON

BEGIN TRY
	BEGIN TRANSACTION

	IF EXISTS(SELECT *
	            FROM [BuildPromotions] BP
				     INNER JOIN [BuildApprovalsReceived] BAR
					         ON BAR.[Build_Id] = BP.[Build_Id]
							AND BAR.[PipelineStage_Name] = BP.[PipelineStage_Name]
			   WHERE BAR.[Approval_Id] = @Approval_Id)
	BEGIN
		RAISERROR('Build has already been promoted. Cannot delete approval.', 16, 1)
	END

	DELETE [BuildApprovalsReceived]
	 WHERE [Approval_Id] = @Approval_Id

	COMMIT
END TRY BEGIN CATCH
	IF XACT_STATE()<>0 ROLLBACK
	EXEC [HandleError]
END CATCH

END
GO

GRANT EXECUTE ON [Promotions_DeleteApproval] TO [BuildMasterUser_Role]