EXEC [dbo].[__BuildMaster_AddStoredProcInfo]
    /* StoredProc_Name         */ 'Rafts_DeleteRaftItemVersion',
    /* Internal_Indicator      */ 'N',
    /* ReturnType_Name         */ 'void',
    /* DataTableNames_Csv      */ NULL,
    /* OutputPropertyNames_Csv */ NULL,
    /* Description_Text        */ 'Deletes a database raft item version.'
GO

IF OBJECT_ID('[Rafts_DeleteRaftItemVersion]') IS NOT NULL DROP PROCEDURE [Rafts_DeleteRaftItemVersion]
GO

SET QUOTED_IDENTIFIER ON
GO

CREATE PROCEDURE [Rafts_DeleteRaftItemVersion]
(
	@RaftItem_Id INT,
	@RaftItemVersion_Number INT
)
AS
BEGIN

SET NOCOUNT ON

BEGIN TRY
	BEGIN TRANSACTION

	DELETE [RaftItemVersions]
	 WHERE [RaftItem_Id] = @RaftItem_Id
	   AND [RaftItemVersion_Number] = @RaftItemVersion_Number

	COMMIT
END TRY BEGIN CATCH
	IF XACT_STATE()<>0 ROLLBACK
	EXEC [HandleError]
END CATCH


END
GO

GRANT EXECUTE ON [Rafts_DeleteRaftItemVersion] TO [BuildMasterUser_Role]
