EXEC [dbo].[__BuildMaster_AddStoredProcInfo]
    /* StoredProc_Name         */ 'Rafts_GetApplicationRaftItems',
    /* Internal_Indicator      */ 'N',
    /* ReturnType_Name         */ 'DataTable',
    /* DataTableNames_Csv      */ 'RaftItems_Extended',
    /* OutputPropertyNames_Csv */ NULL,
    /* Description_Text        */ 'Gets the specified database application raft items.'
GO

IF OBJECT_ID('[Rafts_GetApplicationRaftItems]') IS NOT NULL DROP PROCEDURE [Rafts_GetApplicationRaftItems]
GO

SET QUOTED_IDENTIFIER ON
GO

CREATE PROCEDURE [Rafts_GetApplicationRaftItems]
(
    @Raft_Id INT,
	@RaftItemType_Code INT = NULL,
	@RaftItem_Name VARCHAR(200) = NULL,
	@Application_Id INT = NULL
)
AS
BEGIN

	SET NOCOUNT ON

	SELECT *
	  FROM [RaftItems_Extended]
     WHERE [Raft_Id] = @Raft_Id
	   AND ((@Application_Id IS NULL AND [Application_Id] IS NOT NULL) OR ([Application_Id] = @Application_Id))
	   AND ((@RaftItemType_Code IS NULL) OR ([RaftItemType_Code] = @RaftItemType_Code))
	   AND ((@RaftItem_Name IS NULL) OR ([RaftItem_Name] = @RaftItem_Name))
	   AND [Active_Indicator] = 'Y'

END
GO

GRANT EXECUTE ON [Rafts_GetApplicationRaftItems] TO [BuildMasterUser_Role]