﻿IF OBJECT_ID('[Webhooks_SetLastRunDate]') IS NOT NULL DROP PROCEDURE [Webhooks_SetLastRunDate]
GO

SET QUOTED_IDENTIFIER ON
GO

EXEC [dbo].[__BuildMaster_AddStoredProcInfo]
    /* StoredProc_Name         */ 'Webhooks_SetLastRunDate',
    /* Internal_Indicator      */ 'Y',
    /* ReturnType_Name         */ 'void',
    /* DataTableNames_Csv      */ NULL,
    /* OutputPropertyNames_Csv */ NULL,
    /* Description_Text        */ 'Sets the last run date of a webhook.'
GO

CREATE PROCEDURE [Webhooks_SetLastRunDate]
(
	@Webhook_Id INT,
	@LastRun_Date DATETIME
)
AS
BEGIN

SET NOCOUNT ON

BEGIN TRY
	BEGIN TRANSACTION

	UPDATE [Webhooks]
	   SET [LastRun_Date] = @LastRun_Date
	 WHERE [Webhook_Id] = @Webhook_Id

	COMMIT
END TRY BEGIN CATCH
	IF XACT_STATE()<>0 ROLLBACK
	EXEC [HandleError]
END CATCH

END
GO

GRANT EXECUTE ON [Webhooks_SetLastRunDate] TO [BuildMasterUser_Role]
